#include <sdktools>
#include <vip_core>

#pragma newdecls required

#define VIP_FEATURE	"StickyBomb"

public Plugin myinfo = 
{
	name = "[VIP] Sticky Bomb", //Silly Bomb. Silly - глупый
	author = "HolyHender | Credits: Boeing767 aka asdf",
	description = "",
	version = "1.0.1",
};

ConVar cvar_Distance, cvar_Enable;

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_FEATURE, BOOL, _, _, CB_VIP_OnDispay);
}

public void OnPluginStart()
{
	HookEvent("bomb_planted", Event_BombPlanted);

	cvar_Enable = CreateConVar("sm_vip_sticky_bomb_enable", "1", "Включён ли плагин", _, true, 0.0, true, 1.0);
	cvar_Distance = CreateConVar("sm_vip_sticky_bomb_distance", "65.0", "Дистанция, на которую можно ставить бомбу.");

	AutoExecConfig(true, "sticky_bomb", "vip");
	LoadTranslations("vip_sticky_bomb.phrases");
}

public void OnPluginEnd() 
{
	VIP_UnregisterMe();
}

public bool CB_VIP_OnDispay(int client, const char[] szFeature, char[] szDisplay, int iMaxLength)  // Loco <3
{
	FormatEx(szDisplay, iMaxLength, "%T", "Menu. Display", client);
	VIP_AddStringToggleStatus(szDisplay, szDisplay, iMaxLength, VIP_FEATURE, client);

	return true;
}

public void Event_BombPlanted(Event event, char[] name, bool dontBroadcast)
{
	if(!cvar_Enable.BoolValue)
		return;

	int client = GetClientOfUserId(event.GetInt("userid"));
	if(!VIP_IsClientFeatureUse(client, VIP_FEATURE))
		return;

	int ent = FindEntityByClassname(MaxClients+1, "planted_c4");
	if(!IsValidEntity(ent))
		return;

	float pos[3], ang[3], origin[3];

	GetClientEyePosition(client, pos); 
	GetClientEyeAngles(client, ang); 
	GetClientEyePosition(client, origin);

	TR_TraceRayFilter(pos, ang, MASK_SOLID, RayType_Infinite, TR_Filter, client);
	TR_GetEndPosition(pos);

	if(GetVectorDistance(origin, pos) < cvar_Distance.FloatValue)
	{
		TR_GetPlaneNormal(null, ang);
		GetVectorAngles(ang, ang);

		ang[0] -= 90.0; 
		ang[2] -= 180.0;

		TeleportEntity(ent, pos, ang, NULL_VECTOR);
	}
}

public bool TR_Filter(int iEnt, int iMask, any iEntity)
{
	if(iEnt != iEntity)
		return true;

	return false;
}